unit PicDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Forms, Dialogs, ExtCtrls, JPEG, StdCtrls, ComCtrls, IEDownload, Controls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label6: TLabel;
    Button4: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Button5: TButton;
    ProgressBar1: TProgressBar;
    IEDownload1: TIEDownload;
    procedure Button5Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure MyShow(Sender: TObject);
    procedure MyActivate(Sender: TObject);
    procedure LoadPic();
    procedure Button3Click(Sender: TObject);
    procedure IEDownload1StreamComplete(Sender: TBSCB; Stream: TStream; Result: HRESULT);
    function GetImgStream(const URL: string; NamePic: string): string;
  private
      { Private declarations }
  public
      { Public declarations }
    links, JPGLink: TStringList;
    MovieList: TStringList;
    Kol, All, Page, MaxPage, ReturVal, ExitFlag, Load: Integer;
    Jpeg: array[1..525] of TJPEGImage;
    data: TStringList;
  end;

var
  Form1: TForm1;
  MemoryStream: TMemoryStream;
  StreamGet: Boolean;

implementation

{$R *.dfm}

procedure TForm1.LoadPic();
begin
  Label6.Caption := ' ' + IntToStr(Kol) + ' (c ' + IntToStr(Page + 1) + '  ' + IntToStr(MaxPage + 1) + ')';
  if Kol > 0 + (Page * 3) then
    begin
      Image1.Picture.Bitmap.Assign(Jpeg[1 + (Page * 3)]);
      CheckBox1.Caption := MovieList[0 + (Page * 3)];
      CheckBox1.Visible := True;
      if links[0 + (Page * 3)] = '1' then
        CheckBox1.Checked := True
      else
        CheckBox1.Checked := False;
    end
  else
    begin
      Image1.Picture := nil;
      CheckBox1.Caption := '';
      CheckBox1.Visible := False;
      CheckBox1.Checked := False;
    end;
  if Kol > 1 + (Page * 3) then
    begin
      Image2.Picture.Bitmap.Assign(Jpeg[2 + (Page * 3)]);
      CheckBox2.Caption := MovieList[1 + (Page * 3)];
      CheckBox2.Visible := True;
      if links[1 + (Page * 3)] = '1' then
        CheckBox2.Checked := True
      else
        CheckBox2.Checked := False;
    end
  else
    begin
      Image2.Picture := nil;
      CheckBox2.Caption := '';
      CheckBox2.Visible := False;
      CheckBox2.Checked := False;
    end;
  if Kol > 2 + (Page * 3) then
    begin
      Image3.Picture.Bitmap.Assign(Jpeg[3 + (Page * 3)]);
      CheckBox3.Caption := MovieList[2 + (Page * 3)];
      CheckBox3.Visible := True;
      if links[2 + (Page * 3)] = '1' then
        CheckBox3.Checked := True
      else
        CheckBox3.Checked := False;
    end
  else
    begin
      Image3.Picture := nil;
      CheckBox3.Caption := '';
      CheckBox3.Visible := False;
      CheckBox3.Checked := False;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReturVal := All;
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if Page = MaxPage then
    Page := 0
  else
    if Page < MaxPage then
      Page := Page + 1;
  LoadPic();
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if Page = 0 then
    Page := MaxPage
  else
    if Page > 0 then
      Page := Page - 1;
  LoadPic();
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ReturVal := All + 1;
  Close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ExitFlag := 1;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    links[0 + (Page * 3)] := '1'
  else
    links[0 + (Page * 3)] := '0';
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
    links[1 + (Page * 3)] := '1'
  else
    links[1 + (Page * 3)] := '0';
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked then
    links[2 + (Page * 3)] := '1'
  else
    links[2 + (Page * 3)] := '0';
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  ReturVal := 0 + (Page * 3);
  Close;
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
  ReturVal := 1 + (Page * 3);
  Close;
end;

procedure TForm1.Image3Click(Sender: TObject);
begin
  ReturVal := 2 + (Page * 3);
  Close;
end;

procedure TForm1.MyShow(Sender: TObject);
begin
  Page := 0;
  ReturVal := -1;
  ExitFlag := 0;
  Load := 0;
  MaxPage := Kol div 3;
  if (Kol mod 3) = 0 then
    MaxPage := MaxPage - 1;
  Image1.Picture := nil;
  Image2.Picture := nil;
  Image3.Picture := nil;
  CheckBox1.Visible := False;
  CheckBox1.Checked := False;
  CheckBox2.Visible := False;
  CheckBox2.Checked := False;
  CheckBox3.Visible := False;
  CheckBox3.Checked := False;
  Button1.Visible := False;
  Button2.Visible := False;
  Button3.Visible := False;
  Button4.Visible := False;
  Button5.Visible := True;
  ProgressBar1.Visible := True;
  Label6.Caption := '   ( ' + IntToStr(Kol) + ')';
end;

procedure TForm1.MyActivate(Sender: TObject);
var
  i, SecConter: Integer;
begin
  ProgressBar1.Position := 1;
  Application.ProcessMessages;
  SecConter := 0;
  if Load = 0 then
    begin
      for i := 1 to Kol do
        begin
          if ExitFlag = 0 then
            begin
              try
                MemoryStream := TMemoryStream.Create();
                StreamGet := False;
                IEDownload1.Go(JPGLink[i - 1]);
                while StreamGet <> True do
                  begin
                    Application.ProcessMessages;
                    Sleep(100);
                    SecConter := SecConter + 1;
                    Application.ProcessMessages;
                    if SecConter > 100 then
                      Break;
                  end;
                MemoryStream.Position := 0;
                Jpeg[i] := TJPEGImage.Create();
                Jpeg[i].LoadFromStream(MemoryStream);
                MemoryStream.Free();
              except
                Jpeg[i] := TJPEGImage.Create();
                Jpeg[i] := nil;
              end;
            end
          else
            begin
              Jpeg[i] := TJPEGImage.Create();
              Jpeg[i] := nil;
            end;
          ProgressBar1.Position := Round(100 * i / kol);
          Application.ProcessMessages;
        end;
    end;
  Load := 1;
  LoadPic();
  Button1.Visible := True;
  Button2.Visible := True;
  Button3.Visible := True;
  Button4.Visible := True;
  Button5.Visible := False;
  ProgressBar1.Visible := False;
end;

procedure TForm1.IEDownload1StreamComplete(Sender: TBSCB; Stream: TStream; Result: HRESULT);
begin
  try
    with MemoryStream do
      begin
        Seek(0, 0);
        LoadFromStream(Stream);
      end;
    StreamGet := True;
  except
    StreamGet := False;
  end;
end;

function TForm1.GetImgStream(const URL: string; NamePic: string): string;
var
  SecConter: Integer;
begin
  SecConter := 0;
  try
    MemoryStream := TMemoryStream.Create();
    StreamGet := False;
    IEDownload1.Go(URL);
    while StreamGet <> True do
      begin
        Application.ProcessMessages;
        Sleep(100);
        SecConter := SecConter + 1;
        Application.ProcessMessages;
        if SecConter > 100 then
          Break;
      end;
    MemoryStream.Position := 0;
    MemoryStream.SaveToFile(NamePic);
    MemoryStream.Free();
  except
    NamePic := '';
  end;
  Result := NamePic;
end;

end.

